package org.hmn.jrsd.demo;

import org.hmn.jrsd.demo.orm.CDS;
import org.hmn.jrsd.demo.orm.FRIENDS;

import simpleorm.dataset.SFieldScalar;
import simpleorm.dataset.SRecordInstance;
import simpleorm.sessionjdbc.SSessionJdbc;

/**
 * Field handler that returns the name of the friend instead of the id, for
 * a clearer display
 * 
 * @author karadimas
 */
public class CdFriendTfh
extends TableFieldHandler
{
  LendingCds app;
  
  public CdFriendTfh(SFieldScalar fm,
      JrsdRecordTableModel<CDS> tm,
      LendingCds app) {
    super(fm, tm);
    this.app = app;
  }
  
  @Override
  public Object getValueAt(int rowIndex, int columnIndex) 
  {
    CDS rec = (CDS) tm.getRecord(rowIndex);
    Integer friendsId = rec.getFRIENDS_ID(); 
    if (friendsId == null) return null;
    Friend f = app.getFriend(friendsId);
    if (f == null) return null;
    return f.getLastName();
  }

}
