package org.hmn.jrsd.demo;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;

/*
 * 
 * Cree par Harry Karadimas a 8 sept. 08
 */
public class LendingCdsProperties
{
  public static final String P_JDBC_URL = "jdbc.url";
  public static final String P_JDBC_USER = "jdbc.user";
  public static final String P_JDBC_PASSWORD = "jdbc.password";
  Properties props = new Properties();
  
  public LendingCdsProperties(String propertiesFilePath)
  throws IOException
  {
    File propertiesFile = new File(propertiesFilePath);
    if (!propertiesFile.exists()) {
      throw new FileNotFoundException("Properties file not found");
    }
    FileInputStream fis = new FileInputStream(propertiesFile);
    props.load(fis);
    fis.close();
  }
  
  /**
   * Check properties and if there are missing or illegal values, issue an
   * error message.
   * @return An error message, or null if everything is OK.
   */
  public String checkProperties()
  {
    String msg = null;
    if (getJdbcUrl() == null) return "Missing property : " + P_JDBC_URL;    
    if (getJdbcUser() == null) return "Missing property : " + P_JDBC_USER;    
    if (getJdbcPassword() == null) return "Missing property : " + P_JDBC_PASSWORD;    
    return msg;
  }
  
  public String getJdbcUrl() { return props.getProperty(P_JDBC_URL); }
  
  public String getJdbcUser() { return props.getProperty(P_JDBC_USER); }
  
  public String getJdbcPassword() { return props.getProperty(P_JDBC_PASSWORD); }
  
}
