/**
 * 
 */
package org.hmn.jrsd.test;

import java.sql.ResultSet;
import java.sql.Statement;
import java.util.List;

import org.apache.log4j.Logger;
import org.hmn.jrsd.Jrsd;
import org.hmn.jrsd.rt.SormUtils;

import simpleorm.sessionjdbc.SSessionJdbc;

/**
 * @author KARADIMAS
 */
public class CustomTypeTests
  extends OraJrsdTestCase
{
  static Logger lg = Logger.getLogger(FieldListTests.class);
  
  /**
   * @see junit.framework.TestCase#setUp()
   */
  protected void setUp()
  throws Exception 
  {
    super.setUp();
    beginConnection("setUp");
    if (SormUtils.tableExists("TEST_CUSTOM_TYPE")) {
      SormUtils.ddl("DROP TABLE TEST_CUSTOM_TYPE");
    }
    String sqlsStr = SormUtils.loadResourceAsString("/sql/table-TEST_CUSTOM_TYPE_v1_3813181224.sql");
    System.out.println("sqlsStr ["+sqlsStr+"]");
    List<String> sqls = SormUtils.separateSqlInstructions(sqlsStr);
    for (String sql : sqls) {
      System.out.println("sql:["+sql+"]");
      SormUtils.ddl(sql);
    }
    endConnection();
  }
    
  /**
   * Test that using the custom type, writing to the field puts the expected
   * silly string in the database, and reading back through the field gives
   * the original string again.
   * @throws Exception
   */
  public void testWrite1() 
  throws Exception
  {
    SSessionJdbc session = beginConnection("testWrite1");
    TEST_CUSTOM_TYPE rec = session.findOrCreate(TEST_CUSTOM_TYPE.meta, 1);
    rec.assertNewRow();
    rec.setString(TEST_CUSTOM_TYPE.MYCUSTOMTYPE, "Hello, world !");
    String expected = "Khoor, zruog !";
    Statement st = session.getJdbcConnection().createStatement();
    ResultSet rs = st.executeQuery("SELECT MYCUSTOMTYPE FROM TEST_CUSTOM_TYPE WHERE ID=1");
    while (rs.next()) {
      String actual = rs.getString(1);
      assertEquals(expected, actual);
    }
    session.flushAndPurge();
    rec = session.find(TEST_CUSTOM_TYPE.meta, 1);
    rec.assertNotNewRow();
    String actual = rec.getString(TEST_CUSTOM_TYPE.MYCUSTOMTYPE);
    expected = "Hello, world !";
    assertEquals(expected, actual);
    endConnection();
  }           
  
}
