package org.hmn.jrsd.test;

import java.io.ByteArrayInputStream;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;

import org.hmn.jrsd.rt.SormUtils;

import simpleorm.sessionjdbc.SSessionJdbc;

/*
 * 
 * Cree par Harry Karadimas a 4 oct. 08
 */
public class H2BlobsTests
extends H2JrsdTestCase
{
  @Override
  protected void setUp()
  throws Exception 
  {
    new H2Driver().registerDriver();
    super.setUp();
    SSessionJdbc session = beginConnection("setUp");
    if (SormUtils.tableExists("H2_BLOB")) {
      SormUtils.ddl("DROP TABLE H2_BLOB");
    }
    String sql = SormUtils.loadResourceAsString("/sql/table-H2_BLOB_v1_1901892365.sql");
    SormUtils.ddl(sql);
    endConnection();
  }
  
  public void testWriteNewBlob()
  throws Exception
  {
    SSessionJdbc session = beginConnection("testWriteNewBlob");    
    H2_BLOB_gen rec = session.create(H2_BLOB_gen.meta, 1);
    session.flush();
    byte[] ba = new byte[5000];
    for (int i = 0; i < ba.length; i++) {
      ba[i] = (byte)(Math.random() * 256);
    }
    writeToBlob(session, "H2_BLOB", "ID", 1, "BLB", ba);
    endConnection();
  }

  private void writeToBlob(
      SSessionJdbc session, String table, String keyName, Object key, 
      String blobName, byte[] blobValue)
  throws SQLException 
  {
    Connection cxn = session.getJdbcConnection();
    PreparedStatement ps = cxn.prepareStatement("UPDATE "+table+" SET "+blobName+"=? WHERE "+keyName+"=?");
    ByteArrayInputStream bais = new ByteArrayInputStream(blobValue);
    ps.setBinaryStream(1, bais, blobValue.length);
    ps.setObject(2, key);
    ps.execute();
  }
  
  
}
