package org.hmn.jrsd.test;

import java.io.FileInputStream;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.sql.Timestamp;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Properties;

import org.apache.log4j.Logger;
import org.hmn.jrsd.rt.SormUtils;

import simpleorm.dataset.SFieldMeta;
import simpleorm.sessionjdbc.SSessionJdbc;

import junit.framework.TestCase;
/*
 * 
 * Cree par Harry Karadimas a 19 sept. 2006
 */
/**
 * 
 * @author karadimas
 */
public class MasterDetailTests
extends OraJrsdTestCase
{
  static Logger lg = Logger.getLogger(MasterDetailTests.class);
  
  /**
   * @see junit.framework.TestCase#setUp()
   */
  protected void setUp()
  throws Exception 
  {
    String tableName;
    super.setUp();
    beginConnection("setUp");
    tableName = "MASTER_TABLE";
    if (!SormUtils.tableExists(tableName)) {
      System.out.println("Creating table "+tableName);
      SormUtils.ddl("CREATE TABLE MASTER_TABLE    /* version 1 */ (" + 
          "  MASTER_TABLE_ID integer," + 
          "  NAME varchar(30)," + 
          "  PRIMARY KEY (MASTER_TABLE_ID)" + 
          ")"
          );
    }
    SormUtils.ddl("DELETE FROM MASTER_TABLE");
    String colList = "MASTER_TABLE_ID, NAME";
    SormUtils.ddl("INSERT INTO MASTER_TABLE("+colList+") " +
    "VALUES (1, 'FIRST INVOICE')");
    SormUtils.ddl("INSERT INTO MASTER_TABLE("+colList+") " +
    "VALUES (2, 'SECOND INVOICE')");
    SormUtils.ddl("INSERT INTO MASTER_TABLE("+colList+") " +
    "VALUES (3, 'THIRD INVOICE')");
    SormUtils.ddl("INSERT INTO MASTER_TABLE("+colList+") " +
    "VALUES (4, 'FORTH (EMPTY) INVOICE')");
    tableName = "DETAIL_TABLE"; //DETAIL_TABLE_gen.meta.getTableName();
    if (!SormUtils.tableExists(tableName)) {
      System.out.println("Creating table "+tableName);
      SormUtils.ddl("  CREATE TABLE DETAIL_TABLE    /* version 1 */ (" + 
          "  DETAIL_TABLE_ID integer," + 
          "  DESCR varchar(30)," + 
          "  MASTER_TABLE_ID integer," + 
          "  PRIMARY KEY (DETAIL_TABLE_ID)" + 
          ")"
          );
    }
    SormUtils.ddl("DELETE FROM DETAIL_TABLE");
    colList = "DETAIL_TABLE_ID, DESCR, MASTER_TABLE_ID";
    SormUtils.ddl("INSERT INTO DETAIL_TABLE("+colList+") " +
    "VALUES (1, 'PENCIL', 1)");
    SormUtils.ddl("INSERT INTO DETAIL_TABLE("+colList+") " +
    "VALUES (2, 'INK', 1)");
    SormUtils.ddl("INSERT INTO DETAIL_TABLE("+colList+") " +
    "VALUES (3, 'ERAZOR', 1)");
    SormUtils.ddl("INSERT INTO DETAIL_TABLE("+colList+") " +
    "VALUES (4, 'PLANE', 2)");
    SormUtils.ddl("INSERT INTO DETAIL_TABLE("+colList+") " +
    "VALUES (5, 'SHIP', 2)");
    SormUtils.ddl("INSERT INTO DETAIL_TABLE("+colList+") " +
    "VALUES (6, 'LORD OF THE RINGS', 3)");
    SormUtils.ddl("INSERT INTO DETAIL_TABLE("+colList+") " +
    "VALUES (7, 'LONELY RECORD', 9999)");
    endConnection();
  }
    
  public void testSimpleRead()
  {
    SSessionJdbc session = beginConnection("testSimpleRead");
    DETAIL_TABLE_gen rec = 
      session.find(DETAIL_TABLE_gen.meta, 1);
    lg.info("Descr[1]="+rec.getDESCR());
    endConnection();
  }
  
  public void testMDRead1()
  {
    beginConnection("testMDRead1");
    List<DETAIL_TABLE_manual> r = DETAIL_TABLE_manual.getRecordsForMaster(new Integer(1));
    lg.info("r.length="+r.size());
    endConnection();
  }
  
  public void testRefIdRead()
  {
    SSessionJdbc session = beginConnection("testRefIdRead");
    DETAIL_TABLE_gen rec =
      session.find(DETAIL_TABLE_gen.meta, 5);
    Object o = rec.findReference(DETAIL_TABLE_gen.ref_MASTER_TABLE);
    //Object o = rec.getObject(DETAIL_TABLE_gen.ref_MASTER_TABLE);
    lg.info("id="+o);    
    o = DETAIL_TABLE_gen.meta.getFieldNames();
    lg.info("field names="+o);    
    o = DETAIL_TABLE_gen.meta.getField("MASTER_TABLE_ID");
    lg.info("field ="+o);
    o = rec.getObject((SFieldMeta)o);
    lg.info("id="+o);    
    o = rec.getMASTER_TABLE_ID();
    lg.info("id="+o);
    endConnection();
  }
}
