package org.hmn.jrsd.test;

import java.io.FileInputStream;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.sql.Timestamp;
import java.util.Calendar;
import java.util.Date;
import java.util.Properties;

import simpleorm.sessionjdbc.SSessionJdbc;

import junit.framework.TestCase;
/*
 * 
 * Cree par Harry Karadimas a 19 sept. 2006
 */
/**
 * 
 * @author karadimas
 */
public class TransactionTests
extends OraJrsdTestCase
{
  

  /**
   * @see junit.framework.TestCase#setUp()
   */
  protected void setUp()
  throws Exception 
  {    
    super.setUp();
    beginConnection("TransactionTests.setUp");
    SIMPLE_TABLE_Init.init_SIMPLE_TABLE();
    endConnection();
  }
    
  static public String getTableName() {
    String tableName;
    tableName = TEST_SIMPLE_TABLE_gen.meta.getTableName();
    return tableName;
  }

  public void testConcurrentUpdate1() throws Exception
  {
    SSessionJdbc session = beginConnection("testConcurrentUpdate");
    TEST_SIMPLE_TABLE_gen rec =
      session.find(TEST_SIMPLE_TABLE_gen.meta, 1);
    String descr = rec.getDESCR();
    assertEquals(descr, "RECORD WITH ID=1");
    //S ystem.out.println("descr(sorm)="+descr);
    Connection cxn = session.getJdbcConnection();
    //modify outside of simpleorm
    PreparedStatement ps =
      cxn.prepareStatement("UPDATE "+getTableName()+
          " SET DESCR=? WHERE ID=?");
    ps.setString(1, "MODIFIED FIRST REC");
    ps.setInt(2, 1);
    ps.execute();
    ps.close();
    Statement st = cxn.createStatement();
    ResultSet rs = st.executeQuery("SELECT DESCR FROM "+getTableName()+" WHERE ID=1");
    while (rs.next()) { descr = rs.getString(1); }
    rs.close();
    assertEquals(descr, "MODIFIED FIRST REC");
    //S ystem.out.println("descr="+descr);
    rec = session.find(TEST_SIMPLE_TABLE_gen.meta, 1);
    descr = rec.getDESCR();
    //record will be read from cache, so value will not have changed
    assertEquals(descr, "RECORD WITH ID=1");
    //S ystem.out.println("descr(sorm)="+descr);
    endConnection();
  }
  
  public void testConcurrentUpdate2() throws Exception
  {
    SSessionJdbc session1 = beginConnection("testConcurrentUpdate2");
    TEST_SIMPLE_TABLE_gen rec =
      session1.find(TEST_SIMPLE_TABLE_gen.meta, 1);
    String descr = rec.getDESCR();
    assertEquals(descr, "RECORD WITH ID=1");
    //S ystem.out.println("descr(sorm)="+descr);
    Connection cxn1 = session1.getJdbcConnection();
    //modify outside of simpleorm
    PreparedStatement ps =
      cxn1.prepareStatement("UPDATE "+getTableName()+
          " SET DESCR=? WHERE ID=?");
    ps.setString(1, "MODIFIED FIRST REC");
    ps.setInt(2, 1);
    ps.execute();
    ps.close();
    endConnection();
    SSessionJdbc session2 = beginConnection("testConcurrentUpdate2");    
    Connection cxn2 = session2.getJdbcConnection();
    Statement st = cxn2.createStatement();
    ResultSet rs = st.executeQuery("SELECT DESCR FROM "+getTableName()+" WHERE ID=1");
    while (rs.next()) { descr = rs.getString(1); }
    rs.close();
    assertEquals(descr, "MODIFIED FIRST REC");
    //S ystem.out.println("descr="+descr);
    rec = session2.find(TEST_SIMPLE_TABLE_gen.meta, 1);
    descr = rec.getDESCR();
    //record will be NOT be read from cache, so value will be the changed one
    assertEquals(descr, "MODIFIED FIRST REC");
    //S ystem.out.println("descr(sorm)="+descr);
    endConnection();
  }
  
}
