package org.hmn.jrsd.test;

import java.io.FileInputStream;
import java.sql.Connection;
import java.sql.Timestamp;
import java.util.Calendar;
import java.util.Date;
import java.util.Properties;

import org.hmn.jrsd.rt.SormUtils;

import simpleorm.sessionjdbc.SSessionJdbc;
import simpleorm.utils.SException;

import junit.framework.TestCase;
/*
 * 
 * Cree par Harry Karadimas a 19 sept. 2006
 */
/**
 * 
 * @author karadimas
 */
public class TransportFillTests
extends OraJrsdTestCase
{
  private static final String TNAME = "T_TRANSPORT_FILL";
  
  /**
   * @see junit.framework.TestCase#setUp()
   */
  protected void setUp()
  throws Exception 
  {
    super.setUp();
    beginConnection("setUp");
    if (!SormUtils.tableExists(TNAME)) {
      System.out.println("Creating table "+TNAME);
      SormUtils.ddl("CREATE TABLE "+TNAME+"(" +
          "ID INTEGER," +
          "NAME VARCHAR(32)," +
          "MYDATE DATE," +
          "PRIMARY KEY (ID)" +
          ")");
    }
    SormUtils.ddl("DELETE FROM "+TNAME);
    String colList = "ID,NAME,MYDATE";
    SormUtils.ddl("INSERT INTO "+TNAME+"("+colList+") " +
        "VALUES (1, 'FIRST REC', {d '2006-09-18'})");
    SormUtils.ddl("INSERT INTO "+TNAME+"("+colList+") " +
        "VALUES (2, 'SECOND REC', {d '2006-09-15'})");
    endConnection();
  }
    
  public void testDateUpdate() throws Exception
  {
    SSessionJdbc session = beginConnection("testDateUpdate");
    try {
      T_TRANSPORT_FILL rec = session.find(T_TRANSPORT_FILL.meta, 1); 
      rec.setTimestamp(T_TRANSPORT_FILL.mydate, new Date());
    }
    catch (Throwable e) {
      e.printStackTrace();
    }
    endConnection();
  }
  
  public void testPrimaryKeyModification() throws Exception
  {
    SSessionJdbc session = beginConnection("testPrimaryKeyModification");
    try {
      T_TRANSPORT_FILL rec = session.find(T_TRANSPORT_FILL.meta, 1);
      rec.setInt(T_TRANSPORT_FILL.id, 2);
      assertTrue("An exception should have been thrown", false);
    }
    catch (SException ignored) {}
    endConnection();
  }
  
  public void testTransportObjectFill1() throws Exception
  {
    SSessionJdbc session = beginConnection("testTransportObjectFill1");
    T_TRANSPORT_FILL rec = session.find(T_TRANSPORT_FILL.meta, 1);
    TransportTestObject tto = new TransportTestObject();
    T_TRANSPORT_FILL.tms.writeValuesFromTo(rec, tto);
    assertEquals("id should be 1", tto.getId(), 1);
    Calendar cal = Calendar.getInstance();
    cal.clear();
    cal.set(2006, 8, 18);
    assertEquals("date should be "+cal, tto.getObjDate(), new Timestamp(cal.getTimeInMillis()));
    assertEquals("name should be 'FIRST REC'", tto.getObjName(), "FIRST REC");
    endConnection();
  }
  
}
